package org.openxma.dsl.generator.impl.substrategy;

import at.spardat.xma.guidesign.XMAWidget;
import at.spardat.xma.guidesign.impl.BDAttributeImpl;

public class ComboMappingStrategy {
	
	public static boolean isSupported(BDAttributeImpl attributeImpl) {
		String namPropertyType = attributeImpl.getNamPropertyType();
		if (namPropertyType.equals("java.lang.Integer")) {
			return true;
		} else if (namPropertyType.equals("java.lang.Long")) {
			return true;
		} else if (namPropertyType.equals("java.lang.Short")) {
			return true;
		} else if (namPropertyType.equals("java.lang.Byte")) {
			return true;
		}
		return false;
	}	
	
	public static String shortTypeName(BDAttributeImpl attributeImpl) {
		String namPropertyType = attributeImpl.getNamPropertyType();
		int index = namPropertyType.lastIndexOf('.')+1;
		if (index > 1) {
			return namPropertyType.substring(index);
		}
		throw new RuntimeException("Not supported type name: "+namPropertyType);		
	}
	
	public static String genToBusinessData(XMAWidget widget, BDAttributeImpl attributeImpl) {
		String typeName = shortTypeName(attributeImpl);
		return "        "+attributeImpl.getBdObject().getNamInstance()+"."+attributeImpl.getNamSetter()+"(("+widget.getNamModel()+".getSelected() != null && "+widget.getNamModel()+".getSelected().length() > 0) ? "+typeName+".valueOf("+widget.getNamModel()+".getSelected()) : null);\n";
	}

	public static String genToModel(XMAWidget widget, BDAttributeImpl attributeImpl) {
		String typeName = shortTypeName(attributeImpl);		
		return "        "+widget.getNamModel()+".set(("+attributeImpl.getBdObject().getNamInstance()+"."+attributeImpl.getNamGetter()+"() != null) ? "+typeName+".toString("+attributeImpl.getBdObject().getNamInstance()+"."+attributeImpl.getNamGetter()+"()) : null);\n";
	}	

}
